﻿using Breakout.NavigationExtensions.Services;
using Orchard.Environment.Extensions;
using Orchard.UI.Navigation;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace Breakout.NavigationExtensions.Filters
{
    [OrchardFeature("Breakout.NavigationExtensions.MenuItemLayerRules")]
    public class MenuItemLayerPartNavigationFilter : INavigationFilter
    {
        private readonly IMenuItemLayerRuleService menuItemLayerRuleService;

        public MenuItemLayerPartNavigationFilter(IMenuItemLayerRuleService menuItemLayerRuleService) 
        {
            this.menuItemLayerRuleService = menuItemLayerRuleService;
        }

        public IEnumerable<MenuItem> Filter(IEnumerable<MenuItem> menuItems)
        {
            return menuItems.Where(e => menuItemLayerRuleService.EvaluateMenuItem(e));
        }
    }
}