﻿using Breakout.NavigationExtensions.Models;
using Orchard.ContentManagement.Handlers;
using Orchard.Core.Navigation.Models;
using Orchard.Data;
using Orchard.Environment.Extensions;
using System;
using System.Linq;

namespace Breakout.NavigationExtensions.Handlers
{
    [OrchardFeature("Breakout.NavigationExtensions.MenuItemLayerRules")]
    public class MenuItemLayerRulePartHandler : ContentHandler
	{
        public MenuItemLayerRulePartHandler(IRepository<MenuItemLayerRulePartRecord> repository)
		{
			Filters.Add(StorageFilter.For(repository));
            //attach the custom menu item part to the new menu item type.
            Filters.Add(new ActivatingFilter<MenuItemPart>(Definitions.CustomLinkWithRules));
		}
	}
}