﻿using Orchard.Data.Migration;
using Orchard.Environment.Extensions;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace Breakout.NavigationExtensions
{
    [OrchardFeature("Breakout.NavigationExtensions.MenuItemLayerRules")]
    public class MenuItemLayerRulesMigrations : DataMigrationImpl
    {
        public MenuItemLayerRulesMigrations() { }

        public int Create()
        {
            //create the part record 
            MigrationTasks.MenuItemLayer.PartRecordMigration.CreatePartRecord(this.SchemaBuilder);
            //create a menu item type - like custom link
            MigrationTasks.MenuItemLayer.ContentTypesAndParts.CreateNewMenuItemType(this.ContentDefinitionManager);

            return 1;
        }

        public int UpdateFrom1() 
        {
            //allow other menu item types to 
            MigrationTasks.MenuItemLayer.ContentTypesAndParts.AlterLayerPartConfiguration(this.ContentDefinitionManager);

            return 2;
        }

        public int UpdateFrom2() 
        {
            MigrationTasks.MenuItemLayer.PartRecordMigration.AddChildrenLayerRule(this.SchemaBuilder);
            MigrationTasks.MenuItemLayer.ContentTypesAndParts.AddDefaultSettingsForMenuItemLayerPart(this.ContentDefinitionManager);
            return 3;
        }
    }
}