﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Orchard.ContentManagement.MetaData;
using Breakout.NavigationExtensions.Models;
using Orchard.Data.Migration.Schema;
using Orchard.Core.Contents.Extensions;

namespace Breakout.NavigationExtensions.MigrationTasks.MenuItemLayer
{
    internal static class PartRecordMigration
    {
        internal static void CreatePartRecord(SchemaBuilder schemaBuilder)
        {
            schemaBuilder.CreateTable(typeof(MenuItemLayerRulePartRecord).Name, table => table
                                                                                              .ContentPartRecord()
                                                                                              .Column<string>("LayerRule", column => column.Unlimited()));
        }

        internal static void DestroyMenuItemLayerRulePartRecord(SchemaBuilder schemaBuilder) 
        {
            schemaBuilder.DropTable(typeof(MenuItemLayerRulePartRecord).Name);
        }

        internal static void AddChildrenLayerRule(SchemaBuilder schemaBuilder)
        {
            schemaBuilder.AlterTable(typeof(MenuItemLayerRulePartRecord).Name, table => table.AddColumn<string>("ChildrenLayerRule", column => column.Unlimited()));
        }
    }
}