﻿using Breakout.NavigationExtensions.Models.Settings;
using Orchard.ContentManagement;
using Orchard.ContentManagement.MetaData;
using Orchard.ContentManagement.MetaData.Builders;
using Orchard.ContentManagement.MetaData.Models;
using Orchard.ContentManagement.ViewModels;
using Orchard.Environment.Extensions;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;

namespace Breakout.NavigationExtensions.Settings
{
    [OrchardFeature("Breakout.NavigationExtensions.MenuItemLayerRules")]
    public class MenuItemLayerRulePartSettingsHooks : ContentDefinitionEditorEventsBase  
    {
        public override IEnumerable<TemplateViewModel> TypePartEditor(ContentTypePartDefinition definition)
        {
            if (definition.PartDefinition.Name != Definitions.MenuItemLayerRulePart)
                yield break;

            var model = definition.Settings.GetModel<MenuItemLayeRulePartSettings>();

            yield return DefinitionTemplate(model);
        }

        public override IEnumerable<TemplateViewModel> TypePartEditorUpdate(ContentTypePartDefinitionBuilder builder, IUpdateModel updateModel)
        {
            if (builder.Name != Definitions.MenuItemLayerRulePart)
                yield break;

            var model = new MenuItemLayeRulePartSettings();
            var settingsName = typeof(MenuItemLayeRulePartSettings).Name;

            updateModel.TryUpdateModel(model, settingsName, null, null);
            Func<string, string> settingStore = (field) => string.Format("{0}.{1}", settingsName, field);

            builder
                .WithSetting(settingStore("DisableLayerRuleForMenuItem"), model.DisableLayerRuleForMenuItem.ToString())
                .WithSetting(settingStore("DisableLayerRuleForChildrenWithinMenuItem"), model.DisableLayerRuleForChildrenWithinMenuItem.ToString());

            yield return DefinitionTemplate(model);
        }
    }
}